/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package studentcollection;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;
import javax.swing.border.MatteBorder;

/**
 *
 * @author balikm1
 */
public class StudentPanel extends JPanel {
    SeznamStudentu seznam;
  
    public StudentPanel() {
        seznam = new SeznamStudentu();
        initComponents();
        if (seznam.hasDalsi())
            fillStudent(seznam.getDalsi());
    }
    
    private void initComponents() {
        /* item panel */
        pnlItemPanel = new JPanel();
        pnlItemPanel.setBorder(new MatteBorder(10,10,10,10,this.getBackground()));
        pnlItemPanel.setLayout(new GridLayout(4, 2, 5, 5));
        
        JLabel lblName = new JLabel("Jméno:");
        pnlItemPanel.add(lblName);
        lblNameValue = new JLabel();
        pnlItemPanel.add(lblNameValue);
        JLabel lblSurname = new JLabel("Příjmení:");
        pnlItemPanel.add(lblSurname);
        lblSurnameValue = new JLabel();
        pnlItemPanel.add(lblSurnameValue);
        JLabel lblRC = new JLabel("RČ:");
        pnlItemPanel.add(lblRC);
        lblRCValue = new JLabel();
        pnlItemPanel.add(lblRCValue);
        JLabel lblPrumer = new JLabel("Průměr:");
        pnlItemPanel.add(lblPrumer);
        lblPrumerValue = new JLabel();
        pnlItemPanel.add(lblPrumerValue);
        /* end item panel */
        
        /* buttons panel */
        pnlButtonsPanel =  new JPanel();
        pnlButtonsPanel.setBackground(Color.CYAN);
        pnlButtonsPanel.setLayout(new FlowLayout());
        
        JButton btnPrevious = new JButton("<");
        btnPrevious.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if(seznam.hasPredchozi())
                    fillStudent(seznam.getPredchozi());
            }
        });
        pnlButtonsPanel.add(btnPrevious);
        JButton btnNext = new JButton(">");
        btnNext.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if(seznam.hasDalsi())
                    fillStudent(seznam.getDalsi());
            }
        });
        pnlButtonsPanel.add(btnNext);
        JButton btnDelete = new JButton("Smaž");
        btnDelete.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                seznam.smaz();
                fillStudent(seznam.getCurrent());
            }
        });
        pnlButtonsPanel.add(btnDelete);
        /* end buttons panel */
        
        /* edit panel */
        pnlEditPanel =  new JPanel();
        pnlEditPanel.setBorder(new MatteBorder(10,10,10,10,this.getBackground()));
        pnlEditPanel.setLayout(new GridLayout(4, 2, 5, 5));
        
        JLabel lblNameE = new JLabel("Jméno:");
        pnlEditPanel.add(lblNameE);
        txtName = new JTextField("");
        pnlEditPanel.add(txtName);
        JLabel lblSurnameE = new JLabel("Příjmení:");
        pnlEditPanel.add(lblSurnameE);
        txtSurname = new JTextField("");
        pnlEditPanel.add(txtSurname);
        JLabel lblRCE = new JLabel("RČ:");
        pnlEditPanel.add(lblRCE);
        txtRC = new JTextField("");
        pnlEditPanel.add(txtRC);
        JLabel lblPrumerE = new JLabel("Průměr:");
        pnlEditPanel.add(lblPrumerE);
        txtPrumer = new JTextField("");
        pnlEditPanel.add(txtPrumer);
        /* end edit panel */
        
        this.setLayout(new BorderLayout());
        this.setBorder(new MatteBorder(10,10,10,10,this.getBackground()));
        this.add(pnlItemPanel, BorderLayout.NORTH);
        this.add(pnlButtonsPanel, BorderLayout.CENTER);
        JPanel pnlEditPane = new JPanel();
        pnlEditPane.setLayout(new BorderLayout());
        pnlEditPane.add(pnlEditPanel, BorderLayout.CENTER);
        JButton btnPridej = new JButton("Přidej");
        btnPridej.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if(overVstup()) {
                    Student s = new Student(txtName.getText(), txtSurname.getText(), txtRC.getText());
                    s.setPrumer(Double.parseDouble(txtPrumer.getText()));       
                    seznam.pridej(s);
                    fillStudent(seznam.getCurrent());
                }
            }
        });
        pnlEditPane.add(btnPridej, BorderLayout.SOUTH);
        this.add(pnlEditPane, BorderLayout.SOUTH);
    }
    
    private void fillStudent(Student s) {
        if (s != null) {
            lblNameValue.setText(s.getJmeno());
            lblSurnameValue.setText(s.getPrijmeni());
            lblRCValue.setText(s.getRc());
            lblPrumerValue.setText(Double.toString(s.getPrumer()));
        } else {
            lblNameValue.setText("");
            lblSurnameValue.setText("");
            lblRCValue.setText("");
            lblPrumerValue.setText("");
        }
    }
    
    private boolean overVstup() {
        if (txtName.getText().trim().equals("") 
            || txtSurname.getText().trim().equals("")
            || txtRC.getText().trim().equals("")
            || txtPrumer.getText().trim().equals("")) {
                JOptionPane.showMessageDialog(this, "Zadejte všechny vstupní hodnoty!", "Chyba vstupu", JOptionPane.ERROR_MESSAGE);
                return false;
        }
                
        return true;
    }
    
    JPanel pnlItemPanel;
    JPanel pnlButtonsPanel;
    JPanel pnlEditPanel;
    
    JLabel lblNameValue;
    JLabel lblSurnameValue;
    JLabel lblRCValue;
    JLabel lblPrumerValue;
    
    JTextField txtName;
    JTextField txtSurname;
    JTextField txtRC;
    JTextField txtPrumer;
}

